]> git.notmuchmail.org Git - notmuch/blob - test/test-lib.sh
test: fix passwd_sanitize()
[notmuch] / test / test-lib.sh
1 #
2 # Copyright (c) 2005 Junio C Hamano
3 # Copyright (c) 2010 Notmuch Developers
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see https://www.gnu.org/licenses/ .
17
18 if [ ${BASH_VERSINFO[0]} -lt 4 ]; then
19     echo "Error: The notmuch test suite requires a bash version >= 4.0"
20     echo "due to use of associative arrays within the test suite."
21     echo "Please try again with a newer bash (or help us fix the"
22     echo "test suite to be more portable). Thanks."
23     exit 1
24 fi
25
26 # Make sure echo builtin does not expand backslash-escape sequences by default.
27 shopt -u xpg_echo
28
29 # Ensure NOTMUCH_SRCDIR and NOTMUCH_BUILDDIR are set.
30 . $(dirname "$0")/export-dirs.sh || exit 1
31
32 # It appears that people try to run tests without building...
33 if [[ ! -x "$NOTMUCH_BUILDDIR/notmuch" ]]; then
34         echo >&2 'You do not seem to have built notmuch yet.'
35         exit 1
36 fi
37
38 this_test=${0##*/}
39 this_test=${this_test%.sh}
40 this_test_bare=${this_test#T[0-9][0-9][0-9]-}
41
42 # if --tee was passed, write the output not only to the terminal, but
43 # additionally to the file test-results/$BASENAME.out, too.
44 case "$GIT_TEST_TEE_STARTED, $* " in
45 done,*)
46         # do not redirect again
47         ;;
48 *' --tee '*|*' --va'*)
49         mkdir -p test-results
50         BASE=test-results/$this_test
51         (GIT_TEST_TEE_STARTED=done "$BASH" "$0" "$@" 2>&1;
52          echo $? > $BASE.exit) | tee $BASE.out
53         test "$(cat $BASE.exit)" = 0
54         exit
55         ;;
56 esac
57
58 # STDIN from /dev/null. EOF for readers (and ENOTTY for tty related ioctls).
59 exec </dev/null
60
61 # Save STDOUT to fd 6 and STDERR to fd 7.
62 exec 6>&1 7>&2
63 # Make xtrace debugging (when used) use redirected STDERR, with verbose lead:
64 BASH_XTRACEFD=7
65 export PS4='+(${BASH_SOURCE}:${LINENO}): ${FUNCNAME[0]:+${FUNCNAME[0]}(): }'
66
67 # Keep the original TERM for say_color and test_emacs
68 ORIGINAL_TERM=$TERM
69
70 # Set SMART_TERM to vt100 for known dumb/unknown terminal.
71 # Otherwise use whatever TERM is currently used so that
72 # users' actual TERM environments are being used in tests.
73 case ${TERM-} in
74         '' | dumb | unknown )
75                 SMART_TERM=vt100 ;;
76         *)
77                 SMART_TERM=$TERM ;;
78 esac
79
80 # For repeatability, reset the environment to known value.
81 LANG=C
82 LC_ALL=C
83 PAGER=cat
84 TZ=UTC
85 TERM=dumb
86 export LANG LC_ALL PAGER TERM TZ
87 GIT_TEST_CMP=${GIT_TEST_CMP:-diff -u}
88 if [[ ( -n "$TEST_EMACS" && -z "$TEST_EMACSCLIENT" ) || \
89       ( -z "$TEST_EMACS" && -n "$TEST_EMACSCLIENT" ) ]]; then
90     echo "error: must specify both or neither of TEST_EMACS and TEST_EMACSCLIENT" >&2
91     exit 1
92 fi
93 TEST_EMACS=${TEST_EMACS:-${EMACS:-emacs}}
94 TEST_EMACSCLIENT=${TEST_EMACSCLIENT:-emacsclient}
95 TEST_GDB=${TEST_GDB:-gdb}
96 TEST_CC=${TEST_CC:-cc}
97 TEST_CFLAGS=${TEST_CFLAGS:-"-g -O0"}
98 TEST_SHIM_CFLAGS=${TEST_SHIM_CFLAGS:-"-fpic -shared"}
99 TEST_SHIM_LDFLAGS=${TEST_SHIM_LDFLAGS:-"-ldl"}
100
101 # Protect ourselves from common misconfiguration to export
102 # CDPATH into the environment
103 unset CDPATH
104
105 unset GREP_OPTIONS
106
107 # For lib/open.cc:_load_key_file
108 unset XDG_CONFIG_HOME
109
110 # For emacsclient
111 unset ALTERNATE_EDITOR
112
113 # for reproducibility
114 unset EMAIL
115
116 add_gnupg_home ()
117 {
118     [ -e "${GNUPGHOME}/gpg.conf" ] && return
119     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
120     at_exit_function _gnupg_exit
121     mkdir -p -m 0700 "$GNUPGHOME"
122     gpg --no-tty --import <$NOTMUCH_SRCDIR/test/gnupg-secret-key.asc >"$GNUPGHOME"/import.log 2>&1
123     test_debug "cat $GNUPGHOME/import.log"
124     if (gpg --quick-random --version >/dev/null 2>&1) ; then
125         echo quick-random >> "$GNUPGHOME"/gpg.conf
126     elif (gpg --debug-quick-random --version >/dev/null 2>&1) ; then
127         echo debug-quick-random >> "$GNUPGHOME"/gpg.conf
128     fi
129     echo no-emit-version >> "$GNUPGHOME"/gpg.conf
130
131     # Change this if we ship a new test key
132     FINGERPRINT="5AEAB11F5E33DCE875DDB75B6D92612D94E46381"
133     SELF_USERID="Notmuch Test Suite <test_suite@notmuchmail.org> (INSECURE!)"
134     printf '%s:6:\n' "$FINGERPRINT" | gpg --quiet --batch --no-tty --import-ownertrust
135 }
136
137 add_gpgsm_home ()
138 {
139     local fpr
140     [ -e "$GNUPGHOME/gpgsm.conf" ] && return
141     _gnupg_exit () { gpgconf --kill all 2>/dev/null || true; }
142     at_exit_function _gnupg_exit
143     mkdir -p -m 0700 "$GNUPGHOME"
144     openssl pkcs12 -export -passout pass: -inkey "$NOTMUCH_SRCDIR/test/smime/key+cert.pem" \
145         < "$NOTMUCH_SRCDIR/test/smime/test.crt" | \
146         gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
147               --disable-dirmngr --import  >"$GNUPGHOME"/import.log 2>&1 3<<<''
148     fpr=$(gpgsm --batch --list-key test_suite@notmuchmail.org | sed -n 's/.*fingerprint: //p')
149     echo "$fpr S relax" >> "$GNUPGHOME/trustlist.txt"
150     gpgsm --quiet --batch --no-tty --no-common-certs-import --disable-dirmngr --import < $NOTMUCH_SRCDIR/test/smime/ca.crt
151     echo "4D:E0:FF:63:C0:E9:EC:01:29:11:C8:7A:EE:DA:3A:9A:7F:6E:C1:0D S" >> "$GNUPGHOME/trustlist.txt"
152     printf '%s::1\n' include-certs disable-crl-checks | gpgconf --output /dev/null --change-options gpgsm
153     gpgsm --batch --no-tty --no-common-certs-import --pinentry-mode=loopback --passphrase-fd 3 \
154               --disable-dirmngr --import "$NOTMUCH_SRCDIR/test/smime/bob.p12" >>"$GNUPGHOME"/import.log 2>&1 3<<<''
155     test_debug "cat $GNUPGHOME/import.log"
156 }
157
158 # Each test should start with something like this, after copyright notices:
159 #
160 # test_description='Description of this test...
161 # This test checks if command xyzzy does the right thing...
162 # '
163 # . ./test-lib.sh || exit 1
164
165 color=maybe
166
167 while test "$#" -ne 0
168 do
169         case "$1" in
170         -d|--debug)
171                 debug=t; shift ;;
172         -i|--immediate)
173                 immediate=t; shift ;;
174         -h|--help)
175                 help=t; shift ;;
176         -v|--verbose)
177                 verbose=t; shift ;;
178         -q|--quiet)
179                 quiet=t; shift ;;
180         --with-dashes)
181                 with_dashes=t; shift ;;
182         --no-color)
183                 color=; shift ;;
184         --no-python)
185                 # noop now...
186                 shift ;;
187         --valgrind)
188                 valgrind=t; verbose=t; shift ;;
189         --tee)
190                 shift ;; # was handled already
191         *)
192                 echo "error: unknown test option '$1'" >&2; exit 1 ;;
193         esac
194 done
195
196 if test -n "$debug"; then
197     print_subtest () {
198         printf " %-4s" "[$((test_count - 1))]"
199     }
200 else
201     print_subtest () {
202         true
203     }
204 fi
205
206 test -n "$COLORS_WITHOUT_TTY" || [ -t 1 ] || color=
207
208 if [ -n "$color" ] && [ "$ORIGINAL_TERM" != 'dumb' ] && (
209                 TERM=$ORIGINAL_TERM &&
210                 export TERM &&
211                 tput bold
212                 tput setaf
213                 tput sgr0
214         ) >/dev/null 2>&1
215 then
216         color=t
217 else
218         color=
219 fi
220
221 if test -n "$color"; then
222         say_color () {
223                 (
224                 TERM=$ORIGINAL_TERM
225                 export TERM
226                 case "$1" in
227                         error) tput bold; tput setaf 1;; # bold red
228                         skip)  tput bold; tput setaf 2;; # bold green
229                         pass)  tput setaf 2;;            # green
230                         info)  tput setaf 3;;            # brown
231                         *) test -n "$quiet" && return;;
232                 esac
233                 shift
234                 printf " "
235                 printf "$@"
236                 tput sgr0
237                 print_subtest
238                 )
239         }
240 else
241         say_color() {
242                 test -z "$1" && test -n "$quiet" && return
243                 shift
244                 printf " "
245                 printf "$@"
246                 print_subtest
247         }
248 fi
249
250 error () {
251         say_color error "error: $*\n"
252         GIT_EXIT_OK=t
253         exit 1
254 }
255
256 say () {
257         say_color info "$*"
258 }
259
260 test "${test_description}" != "" ||
261 error "Test script did not set test_description."
262
263 if test "$help" = "t"
264 then
265         echo "Tests ${test_description}"
266         exit 0
267 fi
268
269 test_description_printed=
270 print_test_description ()
271 {
272         test -z "$test_description_printed" || return 0
273         echo
274         echo $this_test: "Testing ${test_description}"
275         test_description_printed=1
276 }
277 if [ -z "$NOTMUCH_TEST_QUIET" ]
278 then
279         print_test_description
280 fi
281
282 test_failure=0
283 test_count=0
284 test_fixed=0
285 test_broken=0
286 test_success=0
287
288 declare -a _exit_functions=()
289
290 at_exit_function () {
291         _exit_functions=($1 ${_exit_functions[@]/$1})
292 }
293
294 rm_exit_function () {
295         _exit_functions=(${_exit_functions[@]/$1})
296 }
297
298 _exit_common () {
299         code=$?
300         trap - EXIT
301         set +ex
302         for _fn in ${_exit_functions[@]}; do $_fn; done
303         rm -rf "$TEST_TMPDIR"
304 }
305
306 trap_exit () {
307         _exit_common
308         if test -n "$GIT_EXIT_OK"
309         then
310                 exit $code
311         else
312                 exec >&6
313                 say_color error '%-6s' FATAL
314                 echo " $test_subtest_name"
315                 echo
316                 echo "Unexpected exit while executing $0. Exit code $code."
317                 exit 1
318         fi
319 }
320
321 trap_signal () {
322         _exit_common
323         echo >&6 "FATAL: $0: interrupted by signal" $((code - 128))
324         exit $code
325 }
326
327 die () {
328         _exit_common
329         exec >&6
330         say_color error '%-6s' FATAL
331         echo " $*"
332         echo
333         echo "Unexpected exit while executing $0."
334         exit 1
335 }
336
337 GIT_EXIT_OK=
338 # Note: TEST_TMPDIR *NOT* exported!
339 TEST_TMPDIR=$(mktemp -d "${TMPDIR:-/tmp}/notmuch-test-$$.XXXXXX")
340 # Put GNUPGHOME in TMPDIR to avoid problems with long paths.
341 export GNUPGHOME="${TEST_TMPDIR}/gnupg"
342 trap 'trap_exit' EXIT
343 trap 'trap_signal' HUP INT TERM
344
345 # Deliver a message with emacs and add it to the database
346 #
347 # Uses emacs to generate and deliver a message to the mail store.
348 # Accepts arbitrary extra emacs/elisp functions to modify the message
349 # before sending, which is useful to doing things like attaching files
350 # to the message and encrypting/signing.
351 emacs_deliver_message ()
352 {
353     local subject body smtp_dummy_pid smtp_dummy_port
354     subject="$1"
355     body="$2"
356     shift 2
357     # before we can send a message, we have to prepare the FCC maildir
358     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
359     # eval'ing smtp-dummy --background will set smtp_dummy_pid and -_port
360     smtp_dummy_pid= smtp_dummy_port=
361     eval `$TEST_DIRECTORY/smtp-dummy --background sent_message`
362     test -n "$smtp_dummy_pid" || return 1
363     test -n "$smtp_dummy_port" || return 1
364
365     test_emacs \
366         "(let ((message-send-mail-function 'message-smtpmail-send-it)
367                (mail-host-address \"example.com\")
368                (smtpmail-smtp-server \"localhost\")
369                (smtpmail-smtp-service \"${smtp_dummy_port}\"))
370            (notmuch-mua-mail)
371            (message-goto-to)
372            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
373            (message-goto-subject)
374            (insert \"${subject}\")
375            (message-goto-body)
376            (insert \"${body}\")
377            $*
378            (notmuch-mua-send-and-exit))"
379
380     # In case message was sent properly, client waits for confirmation
381     # before exiting and resuming control here; therefore making sure
382     # that server exits by sending (KILL) signal to it is safe.
383     kill -9 $smtp_dummy_pid
384     notmuch new >/dev/null
385 }
386
387 # Pretend to deliver a message with emacs. Really save it to a file
388 # and add it to the database
389 #
390 # Uses emacs to generate and deliver a message to the mail store.
391 # Accepts arbitrary extra emacs/elisp functions to modify the message
392 # before sending, which is useful to doing things like attaching files
393 # to the message and encrypting/signing.
394 #
395 # If any GNU-style long-arguments (like --quiet or --decrypt=true) are
396 # at the head of the argument list, they are sent directly to "notmuch
397 # new" after message delivery
398 emacs_fcc_message ()
399 {
400     local nmn_args subject body
401     nmn_args=''
402     while [[ "$1" =~ ^-- ]]; do
403         nmn_args="$nmn_args $1"
404         shift
405     done
406     subject="$1"
407     body="$2"
408     shift 2
409     # before we can send a message, we have to prepare the FCC maildir
410     mkdir -p "$MAIL_DIR"/sent/{cur,new,tmp}
411
412     test_emacs \
413         "(let ((message-send-mail-function (lambda () t))
414                (mail-host-address \"example.com\"))
415            (notmuch-mua-mail)
416            (message-goto-to)
417            (insert \"test_suite@notmuchmail.org\nDate: 01 Jan 2000 12:00:00 -0000\")
418            (message-goto-subject)
419            (insert \"${subject}\")
420            (message-goto-body)
421            (insert \"${body}\")
422            $*
423            (let ((mml-secure-smime-sign-with-sender t)
424                  (mml-secure-openpgp-sign-with-sender t))
425              (notmuch-mua-send-and-exit)))" || return 1
426     notmuch new $nmn_args >/dev/null
427 }
428
429 # Add an existing, fixed corpus of email to the database.
430 #
431 # $1 is the corpus dir under corpora to add, using "default" if unset.
432 #
433 # The default corpus is based on about 50 messages from early in the
434 # history of the notmuch mailing list, which allows for reliably
435 # testing commands that need to operate on a not-totally-trivial
436 # number of messages.
437 add_email_corpus ()
438 {
439     local corpus
440     corpus=${1:-default}
441
442     rm -rf ${MAIL_DIR}
443     cp -a $NOTMUCH_SRCDIR/test/corpora/$corpus ${MAIL_DIR}
444     notmuch new >/dev/null || die "'notmuch new' failed while adding email corpus"
445 }
446
447 test_begin_subtest ()
448 {
449     if [ -n "$inside_subtest" ]; then
450         exec 1>&6 2>&7          # Restore stdout and stderr
451         error "bug in test script: Missing test_expect_equal in ${BASH_SOURCE[1]}:${BASH_LINENO[0]}"
452     fi
453     test_subtest_name="$1"
454     test_reset_state_
455     # Redirect test output to the previously prepared file descriptors
456     # 3 and 4 (see below)
457     if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
458     exec >&3 2>&4
459     inside_subtest=t
460 }
461
462 # Pass test if two arguments match
463 #
464 # Note: Unlike all other test_expect_* functions, this function does
465 # not accept a test name. Instead, the caller should call
466 # test_begin_subtest before calling this function in order to set the
467 # name.
468 test_expect_equal ()
469 {
470         local output expected testname
471         exec 1>&6 2>&7          # Restore stdout and stderr
472         if [ -z "$inside_subtest" ]; then
473                 error "bug in the test script: test_expect_equal without test_begin_subtest"
474         fi
475         inside_subtest=
476         test "$#" = 2 ||
477         error "bug in the test script: not 2 parameters to test_expect_equal"
478
479         output="$1"
480         expected="$2"
481         if ! test_skip "$test_subtest_name"
482         then
483                 if [ "$output" = "$expected" ]; then
484                         test_ok_
485                 else
486                         testname=$this_test.$test_count
487                         echo "$expected" > $testname.expected
488                         echo "$output" > $testname.output
489                         test_failure_ "$(diff -u $testname.expected $testname.output)"
490                 fi
491     fi
492 }
493
494 # Like test_expect_equal, but takes two filenames.
495 test_expect_equal_file ()
496 {
497         local file1 file2 testname basename1 basename2
498         exec 1>&6 2>&7          # Restore stdout and stderr
499         if [ -z "$inside_subtest" ]; then
500                 error "bug in the test script: test_expect_equal_file without test_begin_subtest"
501         fi
502         inside_subtest=
503         test "$#" = 2 ||
504         error "bug in the test script: not 2 parameters to test_expect_equal_file"
505
506         file1="$1"
507         file2="$2"
508         if ! test_skip "$test_subtest_name"
509         then
510                 if diff -q "$file1" "$file2" >/dev/null ; then
511                         test_ok_
512                 else
513                         testname=$this_test.$test_count
514                         basename1=`basename "$file1"`
515                         basename2=`basename "$file2"`
516                         cp "$file1" "$testname.$basename1"
517                         cp "$file2" "$testname.$basename2"
518                         test_failure_ "$(diff -u "$testname.$basename1" "$testname.$basename2")"
519                 fi
520     fi
521 }
522
523 # Like test_expect_equal, but arguments are JSON expressions to be
524 # canonicalized before diff'ing.  If an argument cannot be parsed, it
525 # is used unchanged so that there's something to diff against.
526 test_expect_equal_json () {
527     local script output expected
528     # The test suite forces LC_ALL=C, but this causes Python 3 to
529     # decode stdin as ASCII.  We need to read JSON in UTF-8, so
530     # override Python's stdio encoding defaults.
531     script='import json, sys; json.dump(json.load(sys.stdin), sys.stdout, sort_keys=True, indent=4)'
532     output=$(echo "$1" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
533         || echo "$1")
534     expected=$(echo "$2" | PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "$script" \
535         || echo "$2")
536     shift 2
537     test_expect_equal "$output" "$expected" "$@"
538 }
539
540 # Ensure that the argument is valid JSON data.
541 test_valid_json () {
542     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c "import sys, json; json.load(sys.stdin)" <<<"$1"
543     test_expect_equal "$?" 0
544 }
545
546 # Sort the top-level list of JSON data from stdin.
547 test_sort_json () {
548     PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -c \
549         "import sys, json; json.dump(sorted(json.load(sys.stdin)),sys.stdout)"
550 }
551
552 # test for json objects:
553 # read the source of test/json_check_nodes.py (or the output when
554 # invoking it without arguments) for an explanation of the syntax.
555 test_json_nodes () {
556         local output
557         exec 1>&6 2>&7          # Restore stdout and stderr
558         if [ -z "$inside_subtest" ]; then
559                 error "bug in the test script: test_json_eval without test_begin_subtest"
560         fi
561         inside_subtest=
562         test "$#" > 0 ||
563             error "bug in the test script: test_json_nodes needs at least 1 parameter"
564
565         if ! test_skip "$test_subtest_name"
566         then
567             output=$(PYTHONIOENCODING=utf-8 $NOTMUCH_PYTHON -B "$NOTMUCH_SRCDIR"/test/json_check_nodes.py "$@")
568                 if [ "$?" = 0 ]
569                 then
570                         test_ok_
571                 else
572                         test_failure_ "$output"
573                 fi
574         fi
575 }
576
577 test_emacs_expect_t () {
578         local result
579         test "$#" = 1 ||
580         error "bug in the test script: not 1 parameter to test_emacs_expect_t"
581         if [ -z "$inside_subtest" ]; then
582                 error "bug in the test script: test_emacs_expect_t without test_begin_subtest"
583         fi
584
585         # Run the test.
586         if ! test_skip "$test_subtest_name"
587         then
588                 test_emacs "(notmuch-test-run $1)" >/dev/null
589
590                 # Restore state after the test.
591                 exec 1>&6 2>&7          # Restore stdout and stderr
592                 inside_subtest=
593
594                 # Report success/failure.
595                 result=$(cat OUTPUT)
596                 if [ "$result" = t ]
597                 then
598                         test_ok_
599                 else
600                         test_failure_ "${result}"
601                 fi
602         else
603                 # Restore state after the (non) test.
604                 exec 1>&6 2>&7          # Restore stdout and stderr
605                 inside_subtest=
606         fi
607 }
608
609 NOTMUCH_NEW ()
610 {
611     notmuch new "${@}" | grep -v -E -e '^Processed [0-9]*( total)? file|Found [0-9]* total file'
612 }
613
614 NOTMUCH_DUMP_TAGS ()
615 {
616     # this relies on the default format being batch-tag, otherwise some tests will break
617     notmuch dump --include=tags "${@}" | sed '/^#/d' | sort
618 }
619
620 notmuch_drop_mail_headers ()
621 {
622     $NOTMUCH_PYTHON -c '
623 import email, sys
624 msg = email.message_from_file(sys.stdin)
625 for hdr in sys.argv[1:]: del msg[hdr]
626 print(msg.as_string(False))
627 ' "$@"
628 }
629
630 notmuch_exception_sanitize ()
631 {
632     perl -pe 's/(A Xapian exception occurred at .*[.]cc?):([0-9]*)/\1:XXX/'
633 }
634
635 notmuch_search_sanitize ()
636 {
637     perl -pe 's/("?thread"?: ?)("?)................("?)/\1\2XXX\3/'
638 }
639
640 notmuch_search_files_sanitize ()
641 {
642     notmuch_dir_sanitize
643 }
644
645 notmuch_dir_sanitize ()
646 {
647     sed -e "s,$MAIL_DIR,MAIL_DIR," -e "s,${PWD},CWD,g" "$@"
648 }
649
650 NOTMUCH_SHOW_FILENAME_SQUELCH='s,filename:.*/mail,filename:/XXX/mail,'
651 notmuch_show_sanitize ()
652 {
653     sed -e "$NOTMUCH_SHOW_FILENAME_SQUELCH"
654 }
655 notmuch_show_sanitize_all ()
656 {
657     sed \
658         -e 's| filename:.*| filename:XXXXX|' \
659         -e 's| id:[^ ]* | id:XXXXX |' | \
660         notmuch_date_sanitize
661 }
662
663 notmuch_json_show_sanitize ()
664 {
665     sed \
666         -e 's|"id": "[^"]*",|"id": "XXXXX",|g' \
667         -e 's|"Date": "Fri, 05 Jan 2001 [^"]*0000"|"Date": "GENERATED_DATE"|g' \
668         -e 's|"filename": "signature.asc",||g' \
669         -e 's|"filename": \["/[^"]*"\],|"filename": \["YYYYY"\],|g' \
670         -e 's|"timestamp": 97.......|"timestamp": 42|g' \
671         -e 's|"content-length": [1-9][0-9]*|"content-length": "NONZERO"|g'
672 }
673
674 notmuch_emacs_error_sanitize ()
675 {
676     local command
677     command=$1
678     shift
679     for file in "$@"; do
680         echo "=== $file ==="
681         cat "$file"
682     done | sed \
683         -e 's/^\[.*\]$/[XXX]/' \
684         -e "s|^\(command: \)\{0,1\}/.*/$command|\1YYY/$command|"
685 }
686
687 notmuch_date_sanitize ()
688 {
689     sed \
690         -e 's/^Date: Fri, 05 Jan 2001 .*0000/Date: GENERATED_DATE/'
691 }
692
693 notmuch_uuid_sanitize ()
694 {
695     sed 's/[0-9a-f]\{8\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{4\}-[0-9a-f]\{12\}/UUID/g'
696 }
697
698 notmuch_built_with_sanitize ()
699 {
700     sed 's/^built_with[.]\(.*\)=.*$/built_with.\1=something/'
701 }
702
703 notmuch_passwd_sanitize()
704 {
705     ${NOTMUCH_PYTHON} -c'
706 import os, sys, pwd, socket
707
708 pw = pwd.getpwuid(os.getuid())
709 user = pw.pw_name
710 name = pw.pw_gecos.partition(",")[0]
711 fqdn = socket.getfqdn()
712
713 for l in sys.stdin:
714     if user:
715         l = l.replace(user, "USERNAME")
716     if fqdn:
717         l = l.replace(fqdn, "FQDN").replace(".(none)","")
718     if name:
719         l = l.replace(name, "USER_FULL_NAME")
720     sys.stdout.write(l)
721 '
722 }
723
724 notmuch_config_sanitize ()
725 {
726     notmuch_dir_sanitize | notmuch_built_with_sanitize
727 }
728
729 notmuch_show_part ()
730 {
731     awk '/^\014part}/{ f=0 }; { if (f) { print $0 } } /^\014part{ ID: '"$1"'/{ f=1 }'
732 }
733
734 # End of notmuch helper functions
735
736 # Use test_set_prereq to tell that a particular prerequisite is available.
737 #
738 # The prerequisite can later be checked for by using test_have_prereq.
739 #
740 # The single parameter is the prerequisite tag (a simple word, in all
741 # capital letters by convention).
742
743 test_set_prereq () {
744         satisfied="$satisfied$1 "
745 }
746 satisfied=" "
747
748 test_have_prereq () {
749         case $satisfied in
750         *" $1 "*)
751                 : yes, have it ;;
752         *)
753                 ! : nope ;;
754         esac
755 }
756
757 declare -A test_missing_external_prereq_
758 declare -A test_subtest_missing_external_prereq_
759
760 # declare prerequisite for the given external binary
761 test_declare_external_prereq () {
762         local binary
763         binary="$1"
764         test "$#" = 2 && name=$2 || name="$binary(1)"
765
766         if ! hash $binary 2>/dev/null; then
767                 test_missing_external_prereq_["${binary}"]=t
768                 eval "
769 $binary () {
770         test_subtest_missing_external_prereq_[\"${name}\"]=t
771         false
772 }"
773         fi
774 }
775
776 # Explicitly require external prerequisite.  Useful when binary is
777 # called indirectly (e.g. from emacs).
778 # Returns success if dependency is available, failure otherwise.
779 test_require_external_prereq () {
780         local binary
781         binary="$1"
782         if [[ ${test_missing_external_prereq_["${binary}"]} == t ]]; then
783                 # dependency is missing, call the replacement function to note it
784                 eval "$binary"
785         else
786                 true
787         fi
788 }
789
790 # You are not expected to call test_ok_ and test_failure_ directly, use
791 # the text_expect_* functions instead.
792
793 test_ok_ () {
794         if test "$test_subtest_known_broken_" = "t"; then
795                 test_known_broken_ok_
796                 return
797         fi
798         test_success=$(($test_success + 1))
799         if test -n "$NOTMUCH_TEST_QUIET"; then
800                 return 0
801         fi
802         say_color pass "%-6s" "PASS"
803         echo " $test_subtest_name"
804 }
805
806 test_failure_ () {
807         print_test_description
808         if test "$test_subtest_known_broken_" = "t"; then
809                 test_known_broken_failure_ "$@"
810                 return
811         fi
812         test_failure=$(($test_failure + 1))
813         test_failure_message_ "FAIL" "$test_subtest_name" "$@"
814         test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; }
815         return 1
816 }
817
818 test_failure_message_ () {
819         say_color error "%-6s" "$1"
820         echo " $2"
821         shift 2
822         if [ "$#" != "0" ]; then
823                 echo "$@" | sed -e 's/^/        /'
824         fi
825         if test "$verbose" != "t"; then cat test.output; fi
826 }
827
828 test_known_broken_ok_ () {
829         test_reset_state_
830         test_fixed=$(($test_fixed+1))
831         say_color pass "%-6s" "FIXED"
832         echo " $test_subtest_name"
833 }
834
835 test_known_broken_failure_ () {
836         test_reset_state_
837         test_broken=$(($test_broken+1))
838         if [ -z "$NOTMUCH_TEST_QUIET" ]; then
839                 test_failure_message_ "BROKEN" "$test_subtest_name" "$@"
840         else
841                 test_failure_message_ "BROKEN" "$test_subtest_name"
842         fi
843         return 1
844 }
845
846 test_debug () {
847         test "$debug" = "" || eval "$1"
848 }
849
850 test_run_ () {
851         test_cleanup=:
852         if test "$verbose" != "t"; then exec 4>test.output 3>&4; fi
853         eval >&3 2>&4 "$1"
854         eval_ret=$?
855         eval >&3 2>&4 "$test_cleanup"
856         return 0
857 }
858
859 test_skip () {
860         test_count=$(($test_count+1))
861         to_skip=
862         for skp in $NOTMUCH_SKIP_TESTS
863         do
864                 case $this_test.$test_count in
865                 $skp)
866                         to_skip=t
867                         break
868                 esac
869                 case $this_test_bare.$test_count in
870                 $skp)
871                         to_skip=t
872                         break
873                 esac
874         done
875         case "$to_skip" in
876         t)
877                 test_report_skip_ "$@"
878                 ;;
879         *)
880                 test_check_missing_external_prereqs_ "$@"
881                 ;;
882         esac
883 }
884
885 test_check_missing_external_prereqs_ () {
886         if [[ ${#test_subtest_missing_external_prereq_[@]} != 0 ]]; then
887                 say_color skip >&1 "missing prerequisites: "
888                 echo ${!test_subtest_missing_external_prereq_[@]} >&1
889                 test_report_skip_ "$@"
890         else
891                 false
892         fi
893 }
894
895 test_report_skip_ () {
896         test_reset_state_
897         say_color skip >&3 "skipping test:"
898         echo " $@" >&3
899         say_color skip "%-6s" "SKIP"
900         echo " $1"
901 }
902
903 test_subtest_known_broken () {
904         test_subtest_known_broken_=t
905 }
906
907 test_expect_success () {
908         exec 1>&6 2>&7          # Restore stdout and stderr
909         if [ -z "$inside_subtest" ]; then
910                 error "bug in the test script: test_expect_success without test_begin_subtest"
911         fi
912         inside_subtest=
913         test "$#" = 1 ||
914         error "bug in the test script: not 1 parameters to test_expect_success"
915
916         if ! test_skip "$test_subtest_name"
917         then
918                 test_run_ "$1"
919                 run_ret="$?"
920                 # test_run_ may update missing external prerequisites
921                 test_check_missing_external_prereqs_ "$@" ||
922                 if [ "$run_ret" = 0 -a "$eval_ret" = 0 ]
923                 then
924                         test_ok_
925                 else
926                         test_failure_ "$1"
927                 fi
928         fi
929 }
930
931 test_expect_code () {
932         exec 1>&6 2>&7          # Restore stdout and stderr
933         if [ -z "$inside_subtest" ]; then
934                 error "bug in the test script: test_expect_code without test_begin_subtest"
935         fi
936         inside_subtest=
937         test "$#" = 2 ||
938         error "bug in the test script: not 2 parameters to test_expect_code"
939
940         if ! test_skip "$test_subtest_name"
941         then
942                 test_run_ "$2"
943                 run_ret="$?"
944                 # test_run_ may update missing external prerequisites,
945                 test_check_missing_external_prereqs_ "$@" ||
946                 if [ "$run_ret" = 0 -a "$eval_ret" = "$1" ]
947                 then
948                         test_ok_
949                 else
950                         test_failure_ "exit code $eval_ret, expected $1" "$2"
951                 fi
952         fi
953 }
954
955 # This is not among top-level (test_expect_success)
956 # but is a prefix that can be used in the test script, like:
957 #
958 #       test_expect_success 'complain and die' '
959 #           do something &&
960 #           do something else &&
961 #           test_must_fail git checkout ../outerspace
962 #       '
963 #
964 # Writing this as "! git checkout ../outerspace" is wrong, because
965 # the failure could be due to a segv.  We want a controlled failure.
966
967 test_must_fail () {
968         "$@"
969         test $? -gt 0 -a $? -le 129 -o $? -gt 192
970 }
971
972 # test_cmp is a helper function to compare actual and expected output.
973 # You can use it like:
974 #
975 #       test_expect_success 'foo works' '
976 #               echo expected >expected &&
977 #               foo >actual &&
978 #               test_cmp expected actual
979 #       '
980 #
981 # This could be written as either "cmp" or "diff -u", but:
982 # - cmp's output is not nearly as easy to read as diff -u
983 # - not all diff versions understand "-u"
984
985 test_cmp() {
986         $GIT_TEST_CMP "$@"
987 }
988
989 # This function can be used to schedule some commands to be run
990 # unconditionally at the end of the test to restore sanity:
991 #
992 #       test_expect_success 'test core.capslock' '
993 #               git config core.capslock true &&
994 #               test_when_finished "git config --unset core.capslock" &&
995 #               hello world
996 #       '
997 #
998 # That would be roughly equivalent to
999 #
1000 #       test_expect_success 'test core.capslock' '
1001 #               git config core.capslock true &&
1002 #               hello world
1003 #               git config --unset core.capslock
1004 #       '
1005 #
1006 # except that the greeting and config --unset must both succeed for
1007 # the test to pass.
1008
1009 test_when_finished () {
1010         test_cleanup="{ $*
1011                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
1012 }
1013
1014 test_done () {
1015         GIT_EXIT_OK=t
1016         test_results_dir="$TEST_DIRECTORY/test-results"
1017         mkdir -p "$test_results_dir"
1018         test_results_path="$test_results_dir/$this_test"
1019
1020         echo "total $test_count" >> $test_results_path
1021         echo "success $test_success" >> $test_results_path
1022         echo "fixed $test_fixed" >> $test_results_path
1023         echo "broken $test_broken" >> $test_results_path
1024         echo "failed $test_failure" >> $test_results_path
1025         echo "" >> $test_results_path
1026
1027         [ -n "$EMACS_SERVER" ] && test_emacs '(kill-emacs)'
1028
1029         if [ "$test_failure" = "0" ]; then
1030             if [ "$test_broken" = "0" ]; then
1031                 rm -rf "$remove_tmp"
1032             fi
1033             exit 0
1034         else
1035             exit 1
1036         fi
1037 }
1038
1039 emacs_generate_script () {
1040         # Construct a little test script here for the benefit of the user,
1041         # (who can easily run "run_emacs" to get the same emacs environment
1042         # for investigating any failures).
1043         cat <<EOF >"$TMP_DIRECTORY/run_emacs"
1044 #!/bin/sh
1045 export PATH=$PATH
1046 export NOTMUCH_CONFIG=$NOTMUCH_CONFIG
1047
1048 # Here's what we are using here:
1049 #
1050 # --quick               Use minimal customization. This implies --no-init-file,
1051 #                       --no-site-file and (emacs 24) --no-site-lisp
1052 #
1053 # --directory           Ensure that the local elisp sources are found
1054 #
1055 # --load                Force loading of notmuch.el and test-lib.el
1056
1057 exec ${TEST_EMACS} --quick \
1058         --directory "$NOTMUCH_BUILDDIR/emacs" --load notmuch.el \
1059         --directory "$NOTMUCH_SRCDIR/test" --load test-lib.el \
1060         "\$@"
1061 EOF
1062         chmod a+x "$TMP_DIRECTORY/run_emacs"
1063 }
1064
1065 test_emacs () {
1066         # test dependencies beforehand to avoid the waiting loop below
1067         missing_dependencies=
1068         test_require_external_prereq dtach || missing_dependencies=1
1069         test_require_external_prereq emacs || missing_dependencies=1
1070         test_require_external_prereq ${TEST_EMACSCLIENT} || missing_dependencies=1
1071         test -z "$missing_dependencies" || return
1072
1073         if [ -z "$EMACS_SERVER" ]; then
1074                 emacs_tests="$NOTMUCH_SRCDIR/test/${this_test_bare}.el"
1075                 if [ -f "$emacs_tests" ]; then
1076                         load_emacs_tests="--eval '(load \"$emacs_tests\")'"
1077                 else
1078                         load_emacs_tests=
1079                 fi
1080                 server_name="notmuch-test-suite-$$"
1081                 # start a detached session with an emacs server
1082                 # user's TERM (or 'vt100' in case user's TERM is known dumb
1083                 # or unknown) is given to dtach which assumes a minimally
1084                 # VT100-compatible terminal -- and emacs inherits that
1085                 TERM=$SMART_TERM dtach -n "$TEST_TMPDIR/emacs-dtach-socket.$$" \
1086                         sh -c "stty rows 24 cols 80; exec '$TMP_DIRECTORY/run_emacs' \
1087                                 --no-window-system \
1088                                 $load_emacs_tests \
1089                                 --eval '(setq server-name \"$server_name\")' \
1090                                 --eval '(server-start)' \
1091                                 --eval '(orphan-watchdog $$)'" || return
1092                 EMACS_SERVER="$server_name"
1093                 # wait until the emacs server is up
1094                 until test_emacs '()' >/dev/null 2>/dev/null; do
1095                         sleep 1
1096                 done
1097         fi
1098
1099         # Clear test-output output file.  Most Emacs tests end with a
1100         # call to (test-output).  If the test code fails with an
1101         # exception before this call, the output file won't get
1102         # updated.  Since we don't want to compare against an output
1103         # file from another test, so start out with an empty file.
1104         rm -f OUTPUT
1105         touch OUTPUT
1106
1107         ${TEST_EMACSCLIENT} --socket-name="$EMACS_SERVER" --eval "(notmuch-test-progn $*)"
1108 }
1109
1110 test_python() {
1111     # Note: if there is need to print debug information from python program,
1112     # use stdout = os.fdopen(6, 'w') or stderr = os.fdopen(7, 'w')
1113     PYTHONPATH="$NOTMUCH_SRCDIR/bindings/python${PYTHONPATH:+:$PYTHONPATH}" \
1114         $NOTMUCH_PYTHON -B - > OUTPUT
1115 }
1116
1117 test_ruby() {
1118     MAIL_DIR=$MAIL_DIR $NOTMUCH_RUBY -I "$NOTMUCH_BUILDDIR/bindings/ruby"> OUTPUT
1119 }
1120
1121 test_C () {
1122     local exec_file test_file
1123     exec_file="test${test_count}"
1124     test_file="${exec_file}.c"
1125     cat > ${test_file}
1126     ${TEST_CC} ${TEST_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${exec_file} ${test_file} -L${NOTMUCH_BUILDDIR}/lib/ -lnotmuch -ltalloc
1127     echo "== stdout ==" > OUTPUT.stdout
1128     echo "== stderr ==" > OUTPUT.stderr
1129     ./${exec_file} "$@" 1>>OUTPUT.stdout 2>>OUTPUT.stderr
1130     notmuch_dir_sanitize OUTPUT.stdout OUTPUT.stderr | notmuch_exception_sanitize > OUTPUT
1131 }
1132
1133 make_shim () {
1134     local base_name test_file shim_file
1135     base_name="$1"
1136     test_file="${base_name}.c"
1137     shim_file="${base_name}.so"
1138     cat > ${test_file}
1139     ${TEST_CC} ${TEST_CFLAGS} ${TEST_SHIM_CFLAGS} -I${NOTMUCH_SRCDIR}/test -I${NOTMUCH_SRCDIR}/lib -o ${shim_file} ${test_file} ${TEST_SHIM_LDFLAGS}
1140 }
1141
1142 notmuch_with_shim () {
1143     local base_name shim_file
1144     base_name="$1"
1145     shift
1146     shim_file="${base_name}.so"
1147     LD_PRELOAD=${LD_PRELOAD:+:$LD_PRELOAD}:./${shim_file} notmuch-shared "$@"
1148 }
1149
1150 # Creates a script that counts how much time it is executed and calls
1151 # notmuch.  $notmuch_counter_command is set to the path to the
1152 # generated script.  Use notmuch_counter_value() function to get the
1153 # current counter value.
1154 notmuch_counter_reset () {
1155         notmuch_counter_command="$TMP_DIRECTORY/notmuch_counter"
1156         if [ ! -x "$notmuch_counter_command" ]; then
1157                 notmuch_counter_state_path="$TMP_DIRECTORY/notmuch_counter.state"
1158                 cat >"$notmuch_counter_command" <<EOF || return
1159 #!/bin/sh
1160
1161 read count < "$notmuch_counter_state_path"
1162 echo \$((count + 1)) > "$notmuch_counter_state_path"
1163
1164 exec notmuch "\$@"
1165 EOF
1166                 chmod +x "$notmuch_counter_command" || return
1167         fi
1168
1169         echo 0 > "$notmuch_counter_state_path"
1170 }
1171
1172 # Returns the current notmuch counter value.
1173 notmuch_counter_value () {
1174         if [ -r "$notmuch_counter_state_path" ]; then
1175                 read count < "$notmuch_counter_state_path"
1176         else
1177                 count=0
1178         fi
1179         echo $count
1180 }
1181
1182 test_reset_state_ () {
1183         test -z "$test_init_done_" && test_init_
1184
1185         test_subtest_known_broken_=
1186         test_subtest_missing_external_prereq_=()
1187 }
1188
1189 # called once before the first subtest
1190 test_init_ () {
1191         test_init_done_=t
1192
1193         # skip all tests if there were external prerequisites missing during init
1194         test_check_missing_external_prereqs_ "all tests in $this_test" && test_done
1195 }
1196
1197
1198 # Where to run the tests
1199 TEST_DIRECTORY=$NOTMUCH_BUILDDIR/test
1200
1201 . "$NOTMUCH_SRCDIR/test/test-lib-common.sh" || exit 1
1202
1203 emacs_generate_script
1204
1205
1206 # Use -P to resolve symlinks in our working directory so that the cwd
1207 # in subprocesses like git equals our $PWD (for pathname comparisons).
1208 cd -P "$TMP_DIRECTORY" || error "Cannot set up test environment"
1209
1210 if test "$verbose" = "t"
1211 then
1212         exec 4>&2 3>&1
1213 else
1214         exec 4>test.output 3>&4
1215 fi
1216
1217 for skp in $NOTMUCH_SKIP_TESTS
1218 do
1219         to_skip=
1220         for skp in $NOTMUCH_SKIP_TESTS
1221         do
1222                 case "$this_test" in
1223                 $skp)
1224                         to_skip=t
1225                         break
1226                 esac
1227                 case "$this_test_bare" in
1228                 $skp)
1229                         to_skip=t
1230                         break
1231                 esac
1232         done
1233         case "$to_skip" in
1234         t)
1235                 say_color skip >&3 "skipping test $this_test altogether"
1236                 say_color skip "skip all tests in $this_test"
1237                 test_done
1238         esac
1239 done
1240
1241 # Provide an implementation of the 'yes' utility
1242 yes () {
1243         if test $# = 0
1244         then
1245                 y=y
1246         else
1247                 y="$*"
1248         fi
1249
1250         while echo "$y"
1251         do
1252                 :
1253         done
1254 }
1255
1256 # Fix some commands on Windows
1257 case $(uname -s) in
1258 *MINGW*)
1259         # Windows has its own (incompatible) sort and find
1260         sort () {
1261                 /usr/bin/sort "$@"
1262         }
1263         find () {
1264                 /usr/bin/find "$@"
1265         }
1266         sum () {
1267                 md5sum "$@"
1268         }
1269         # git sees Windows-style pwd
1270         pwd () {
1271                 builtin pwd -W
1272         }
1273         # no POSIX permissions
1274         # backslashes in pathspec are converted to '/'
1275         # exec does not inherit the PID
1276         ;;
1277 *)
1278         test_set_prereq POSIXPERM
1279         test_set_prereq BSLASHPSPEC
1280         test_set_prereq EXECKEEPSPID
1281         ;;
1282 esac
1283
1284 test -z "$NO_PERL" && test_set_prereq PERL
1285 test -z "$NO_PYTHON" && test_set_prereq PYTHON
1286
1287 # test whether the filesystem supports symbolic links
1288 ln -s x y 2>/dev/null && test -h y 2>/dev/null && test_set_prereq SYMLINKS
1289 rm -f y
1290
1291 # declare prerequisites for external binaries used in tests
1292 test_declare_external_prereq dtach
1293 test_declare_external_prereq emacs
1294 test_declare_external_prereq ${TEST_EMACSCLIENT}
1295 test_declare_external_prereq ${TEST_GDB}
1296 test_declare_external_prereq gpg
1297 test_declare_external_prereq openssl
1298 test_declare_external_prereq gpgsm
1299 test_declare_external_prereq ${NOTMUCH_PYTHON}
1300 test_declare_external_prereq xapian-metadata
1301 test_declare_external_prereq xapian-delve